function ItemSetGuideInitializer.InitializeGui()
    local headerEntry = ItemSetGuide.Libraries.wm:CreateControlFromVirtual(ItemSetGuideMainWindowContent:GetName().."HeaderRow", ItemSetGuideMainWindowContent, "HeaderEntry")

    ItemSetGuide.Libraries.LibDwemerAssistants.CreateScrollControl(ItemSetGuide.Libraries.wm, ItemSetGuideMainWindowContent, headerEntry, function(control, index) return ItemSetGuideInitializer.CreateRow(control, index) end, function(control) ItemSetGuide.FillDataRow(control) end, nil)

    ItemSetGuideInitializer.CreateDetailView()

    ItemSetGuideInitializer.CreateSearchView()
end

function ItemSetGuideInitializer.CreateSearchView()
    ItemSetGuideMainWindowSearchWindowSetType.dropdown = ZO_ComboBox_ObjectFromContainer(ItemSetGuideMainWindowSearchWindowSetType)
    ItemSetGuideMainWindowSearchWindowSlot.dropdown = ZO_ComboBox_ObjectFromContainer(ItemSetGuideMainWindowSearchWindowSlot)
    ItemSetGuideMainWindowSearchWindowItemType.dropdown = ZO_ComboBox_ObjectFromContainer(ItemSetGuideMainWindowSearchWindowItemType)
    
    ItemSetGuide.FillDropDown(ItemSetGuideMainWindowSearchWindowSetType, ItemSetGuide.Localization.SetTypes, nil, ItemSetGuide.SetTypeSelectionChanged)
    ItemSetGuide.FillDropDown(ItemSetGuideMainWindowSearchWindowSlot, ItemSetGuide.Localization.EquipSlots, { EQUIP_SLOT_MAIN_HAND, EQUIP_SLOT_OFF_HAND, EQUIP_SLOT_NECK, EQUIP_SLOT_RING1, EQUIP_SLOT_HEAD, EQUIP_SLOT_SHOULDERS, EQUIP_SLOT_CHEST, EQUIP_SLOT_HAND, EQUIP_SLOT_WAIST, EQUIP_SLOT_LEGS, EQUIP_SLOT_FEET,}, ItemSetGuide.EquipSlotSelectionChanged)
end

function ItemSetGuideInitializer.CreateDetailView()
    ItemSetGuideMainWindowDetailView.items = {}

    local previousControl
    local i
    for i = 1, 12, 1 do
        local detailItem = ItemSetGuide.Libraries.wm:CreateControlFromVirtual(ItemSetGuideMainWindowDetailView:GetName().."Item"..i, ItemSetGuideMainWindowDetailView, "ItemSetGuideDetailItem")

        if previousControl == nil then
            detailItem:SetAnchor(TOPLEFT, ItemSetGuideMainWindowDetailView, TOPLEFT, 5, 33)
        else
            detailItem:SetAnchor(TOPLEFT, previousControl, TOPRIGHT, 5, 0)
        end

        detailItem.itemIndex = i
        detailItem:SetHandler("OnMouseEnter", function(self) ItemSetGuide.HandleItemButtonMouseEnter(self, self:GetParent().rowData, self:GetParent().itemSlotName, self.itemIndex) end)
        detailItem:SetHandler("OnMouseExit", function(self) ItemSetGuide.HandleItemButtonMouseExit(self) end)
        detailItem:SetHidden(true)

        ItemSetGuideMainWindowDetailView.items[i] = detailItem
        previousControl = detailItem
    end
end

function ItemSetGuideInitializer.CreateRow(control, index)
    local row = ItemSetGuide.Libraries.wm:CreateControlFromVirtual(control:GetName().."ItemEntry"..index, control, "ItemEntry")

    local setnameControl = row:GetNamedChild("Setname")
    setnameControl:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
    setnameControl:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)

    local craftControl = row:GetNamedChild("Craft")
    craftControl:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
    craftControl:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)

    local levelControl = row:GetNamedChild("Level")
    levelControl:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
    levelControl:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)

    ItemSetGuideInitializer.CreateSetItem(wm, row, "MH", "MainHand", 1)
    ItemSetGuideInitializer.CreateSetItem(wm, row, "OH", "OffHand", 1)
    ItemSetGuideInitializer.CreateSetItem(wm, row, "Neck", "Neck", 1)
    ItemSetGuideInitializer.CreateSetItem(wm, row, "Ring1", "Ring", 1)
    ItemSetGuideInitializer.CreateSetItem(wm, row, "Ring2", "Ring", 2)
    ItemSetGuideInitializer.CreateSetItem(wm, row, "Head", "Head", 1)
    ItemSetGuideInitializer.CreateSetItem(wm, row, "Shoulders", "Shoulders", 1)
    ItemSetGuideInitializer.CreateSetItem(wm, row, "Chest", "Chest", 1)
    ItemSetGuideInitializer.CreateSetItem(wm, row, "Hands", "Hands", 1)
    ItemSetGuideInitializer.CreateSetItem(wm, row, "Waist", "Waist", 1)
    ItemSetGuideInitializer.CreateSetItem(wm, row, "Legs", "Legs", 1)
    ItemSetGuideInitializer.CreateSetItem(wm, row, "Feet", "Feet", 1)

    ItemSetGuideInitializer.InitializeLocation(row, "LocationAldmeriDominion")
    ItemSetGuideInitializer.InitializeLocation(row, "LocationEbonheartPact")
    ItemSetGuideInitializer.InitializeLocation(row, "LocationDaggerfallCovenant")

    return row
end

function ItemSetGuideInitializer.InitializeLocation(row, subControlName)
    local setnameControl = row:GetNamedChild(subControlName)
    setnameControl:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
    setnameControl:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)
end

function ItemSetGuideInitializer.CreateSetItem(wm, control, subControlName, itemSlotName, itemIndex)
    local subControl = control:GetNamedChild(subControlName)    

    subControl.buttonAccept = ItemSetGuideInitializer.CreateSetItemButton(wm, control:GetName()..subControlName.."ButtonAccept", subControl, "ESOUI/art/buttons/accept_up.dds", "ESOUI/art/buttons/accept_over.dds", itemSlotName, itemIndex, {0, 1, 0, 1})
    subControl.buttonPlus = ItemSetGuideInitializer.CreateSetItemButton(wm, control:GetName()..subControlName.."ButtonPlus", subControl, "ESOUI/art/buttons/pointsplus_up.dds", "ESOUI/art/buttons/pointsplus_over.dds", itemSlotName, itemIndex, {0.8, 0.8, 0.8, 1})
    subControl.buttonDecline = ItemSetGuideInitializer.CreateSetItemButton(wm, control:GetName()..subControlName.."ButtonDecline", subControl, "ESOUI/art/buttons/decline_up.dds", "ESOUI/art/buttons/decline_over.dds", itemSlotName, itemIndex, {1, 0, 0, 0.8})
end

function ItemSetGuideInitializer.CreateSetItemButton(wm, buttonName, subControl, texture, mouseOverTexture, itemSlotName, itemIndex, color)
    local button = ItemSetGuide.Libraries.wm:CreateControl(buttonName, subControl, CT_BUTTON)
    button:SetDimensions(23, 23)
    button:SetAnchor(CENTER, subControl, CENTER, -1.5, -1)
    button:SetMouseOverTexture(mouseOverTexture)
    button:SetHidden(true)

    button.itemSlotName = itemSlotName
    button.itemIndex = itemIndex

    button:SetHandler("OnMouseEnter", function(self) ItemSetGuide.HandleItemButtonMouseEnter(self, self:GetParent():GetParent().rowData, self.itemSlotName, self.itemIndex) end)
    button:SetHandler("OnMouseExit", function(self) ItemSetGuide.HandleItemButtonMouseExit(self) end)
    button:SetHandler("OnClicked", function()
            ItemSetGuide.SetDetailViewData(subControl:GetParent().rowData, button.itemSlotName)
            ItemSetGuideMainWindowDetailView:SetHidden(false)
        end)

    local icon = ItemSetGuide.Libraries.wm:CreateControl(buttonName.."Texture", button, CT_TEXTURE)
    icon:SetDimensions(23, 23)
    icon:SetAnchor(CENTER, button, CENTER)
    icon:SetColor(unpack(color))
    icon:SetTexture(texture)

    return button
end