local majorVersion = "LibSettings-1"
local minorVersion = "0.1"

local libSettings = LibStub:NewLibrary(majorVersion, minorVersion)

if not libSettings then
    return    -- already loaded and no upgrade necessary
end

function libSettings.LoadAccountWideSettings(variablesName, version, defaults)
    return ZO_SavedVars:NewAccountWide(variablesName, version, nil, defaults)
end

function libSettings.LoadCharacterSettings(variablesName, version, defaults)
    return ZO_SavedVars:New(variablesName, version, nil, defaults)
end

function libSettings.CreateSettingsMenu(panelIdentifier, panelDefinition, settingsMenuDefinition, LAM2)
    local panel = LAM2:RegisterAddonPanel(panelIdentifier, panelDefinition)
    LAM2:RegisterOptionControls(panelIdentifier, settingsMenuDefinition)
    
    return panel
end